#ifndef  TIME_STORMAMIGA_H
#define  TIME_STORMAMIGA_H

/*
**      $VER: time_stormamiga.h 1.1 (18.09.98)
**             Includes Release 44.10
**
**     Copyright  1996/98 by CyberdyneSystems
**
**            written by Matthias Henze
**               All Rights Reserved
*/

#ifndef  STORMAMIGA_H
  #include <stormamiga.h>
#endif
#ifndef _INCLUDE_TIME_H
  #include <time.h>
#endif

#ifdef __cplusplus
  extern "C" {
#endif

#define CLK_TCK   50

/*----- stormamiga-functions -----*/

#ifdef STORMAMIGA_DEUTSCH
  #define strftime    strftime_d
  #define asctime     asctime_d
  #define ctime       ctime_d
#endif

int   strftime_d      (char *, uint, cchar *, const struct tm *);
char  *asctime_d      (const struct tm *);
char  *ctime_d        (const time_t *);

#ifdef __cplusplus
  }
#endif

#ifdef STORMAMIGA_INLINE

/*----- ANSI C-functions -----*/

__inline struct tm *localtime (const time_t *tp)
{ return gmtime          (tp); }

#ifndef STORMAMIGA_DEUTSCH
  __inline char *ctime   (const time_t *t)
  { return asctime       (localtime (t)); }
#endif

__inline double difftime (time_t t1, time_t t2)
{ return (t1 - t2); }

/*----- stormamiga-functions -----*/

__inline char *ctime_d   (const time_t *t)
{ return asctime_d       (localtime (t)); }
#endif  /* STORMAMIGA_INLINE */

#endif  /* TIME_STORMAMIGA_H */
